# API basics

Custom interface provides API which main goal is to interact with BAS. Each API method may be called from any place inside javascript code. For example, following code will immediately restart script:

```javascript
Api.Restart()
```

If you place that code inside button click handler, then click on that button will cause entire script to restart. Restart method will return immediately, but other methods may require time to finish. In that case method will return a Promise object, use _then_ keyword to obtain result:


```javascript
Api.GetGlobalVariable("TEST").then(function(res){
    console.log(res)
})
```

Custom interface may receive events from BAS. Events are used to notify interface about number of threads changed, about new log messages or any other script state change. Every time BAS wants to inform interface about something, it sends an event. Custom interface must set an event handler one time on page load, like this:

```javascript
//Set event handler
Api.SetEventHandler(function(EventType, EventData) {
   //Process log event
   if (EventType == "log") {
      //Obtain log text
      var Text = EventData["text"]

      //Output text to the browser console
      console.log(Text)
   }

})
```

That handler will be called on every event. You can check examples in default interface implementation. Below you can see the list of API methods and events grouped by theirs purpose.


