# Solving captcha

BAS has several captcha solvers. Most of them works automatically, but _manual_ solver requires user to recognize image manually. Therefore custom interface must display captcha and deliver result to BAS.

## Event _captcha_

```javascript
if (EventType == "captcha") {
   var CaptchaId = EventData["id"]
   var IsCaptchaImage = EventData["is_image"]
   var CaptchaData = EventData["data"]
}
```

This event is triggered only after manual captcha determination is required. Custom interface must display that captcha to user and when result is obtained, _CaptchaSolved_ method must be called. EventData["id"] contains captcha id, it should be used with _CaptchaSolved_ method to identify for which captcha the result is sent. EventData["is_image"] can be true or false. If it equals true, then EventData["data"] contains base64 encoded image in png format, otherwise EventData["data"] contains text. If EventData["is_image"] equals to false, it means that BAS sends text captcha.


## Method _CaptchaSolved_

```javascript
Api.CaptchaSolved(CaptchaId,IsSuccess,Text)
```

Use this method to send solved catpcha text back to BAS.

First parameter is captcha id obtained from _captcha_ event.

Second parameter is true if user have solved captcha, otherwise false.

Third parameter is captcha text.



