# Updating project settings dynamically

Global variables may be used to update project settings. Consider following task - we need to make a script that does specified number of clicks and that number may be changed by user dynamically. 

We will take click number from global variable CLICK_NUMBER. That variable will be updated from user interface and will be used inside BAS script. We will not include any real functionality inside script, just 2 actions to demonstrate how it work:

<p align="center">
![](//wiki.bablosoft.com/lib/exe/fetch.php?cache=&media=scriptupdatefromgloablvariable.png ':size=300')
</p>

You can download project [here](https://bablosoft.com/uploads/ScriptAndUIInteraction.xml).

Project interface is based on autogenerated with several changes: 
  * All resources inputs are removed.
  * Interface immediately calls Api.AcceptResources() to change state to running.
  * All controls which displays script statistic, browser view are removed, only log panel left.
  * Finally range control is added, to let user select click number:


<p align="center">
![](//wiki.bablosoft.com/lib/exe/fetch.php?cache=&media=numberofclicksinterface.png ':size=300')
</p>

  * Added code to set global variable on range control value changed:

```javascript
$("#NumberOfClicks").change(function() {
    var value = $("#NumberOfClicks").val()
    Api.SetGlobalVariable("CLICK_NUMBER", value)
});
```

You can download custom interface [here](https://bablosoft.com/uploads/ScriptAndUIInteraction.main.interface.txt). Custom interface may be imported on following page:

<p align="center">
![](//wiki.bablosoft.com/lib/exe/fetch.php?cache=&media=importcustominterface.png ':size=300')
</p>

Final result will look like this:

<p align="center">
![](//wiki.bablosoft.com/lib/exe/fetch.php?cache=&media=updateglobalvariablefromwebinterface.gif ':size=300')
</p>

This mechanism can be used in the other direction - to send data from BAS script to custom interface.


