
# Editing basics

Custom interface consists of two pages: main and login. Login page has only login form and logs about connection process. It is hidden right after login was successful and visible to every user, even not authorized. Whole script functionality is located on main page. Main page is visible to authorized users only. Typically it contains resources selection dialog, where all inputs are located and script dashboard with information about script execution.

We will edit only main page, but same approach may be applied to login page. To start editing click on _Edit interface_ button:

<p align="center">
![](//wiki.bablosoft.com/lib/exe/fetch.php?cache=&media=editinterface.png ':size=300')
</p>


After that you can see interface which may look a little bit complex, but don't worry, everything will be explained in this manual. Take a look at a central part, this is custom interface, which was generated automatically. It looks not exactly the same as user will see it, to look at final state, you need to click on preview button:

<p align="center">
![](//wiki.bablosoft.com/lib/exe/fetch.php?cache=&media=previewinterface.png ':size=300')
</p>

Now click on _X_ button to close the preview(at the right-top corner) and lets make a simplest possible change to user interface that we can do - edit script title. To do that, click on it and input new value, like this:

<p align="center">
![](//wiki.bablosoft.com/lib/exe/fetch.php?cache=&media=customscripttitle.gif ':size=300')
</p>


Another way to change label text is by editing its properties. Click on a label to select it and visit properties tab. It has cog icon and located at top-right corner. Each item inside big central panel is element, different elements has different types. And each element type has some properties. For example, element, that we currently selected has property _Text_, and if we change it on properties panel, changes will be reflected inside user interface:

<p align="center">
![](//wiki.bablosoft.com/lib/exe/fetch.php?cache=&media=updatetitlethroughproperties.gif ':size=300')
</p>


Right now we made some changes to script interface, but if we try to run it in BAS, we will still see old interface version. To update script interface, we need to click on _Save changes on server_ button:

<p align="center">
![](//wiki.bablosoft.com/lib/exe/fetch.php?cache=&media=savechangesonserver.png ':size=300')
</p>


Now changes are reflected in BAS for you and all your users. But if you select resources and proceed to next page, you will see old title. That is because default interface contains two tabs: _Resources_ and _Script progress_. We have changed title inside first tab, now we need to change it for the second one. Go to the editor, click on _Script progress_ to switch tab and change title there:

<p align="center">
![](//wiki.bablosoft.com/lib/exe/fetch.php?cache=&media=updatetitleonsecondtab.gif ':size=300')
</p>

Element with _Tabs_ type used very often inside default interface, and you can easily add new tabs, or change existing.


# Changing styles

Changing element style may be accomplished by using _Styles_ panel. First of all select element by clicking on it, then click on tassel icon in the top right screen corner. This panel works almost in a same way as element properties, except there is more settings for stlye, than properties, so this panel contains several groups. Lets change title color and font size. Corresponding settings are located in _Typography_ group:

<p align="center">
![](//wiki.bablosoft.com/lib/exe/fetch.php?cache=&media=changestyles.gif ':size=300')
</p>


There are a lot of styles and describing each one is out of scope of this manual. But one important thing is _Flex_ group. Settings from this group are related to [css flexbox layouts](https://www.w3schools.com/css/css3_flexbox.asp). These settings helps to position elements and heavily used for default interface. See how several button may be arranged inside flex container:

<p align="center">
![](//wiki.bablosoft.com/lib/exe/fetch.php?cache=&media=flexcontainer.gif ':size=300')
</p>


# Elements hierarchy

Elements are organized in a tree structure, just like DOM in html. Each element may have single parent and several or none children. You can view element tree in corresponding panel:

<p align="center">
![](//wiki.bablosoft.com/lib/exe/fetch.php?cache=&media=editinterface2.png ':size=300')
</p>

# Creating new elements

Last unexamined panel is panel that contains available element list, you can drag element from there and drop it anywhere into interface. Next gif shows how to add link to your website:

<p align="center">
![](//wiki.bablosoft.com/lib/exe/fetch.php?cache=&media=addlinktowebsite.gif ':size=300')
</p>

Previous video should be self explanatory - we are dragging new element near script title, arrange it to the right, tweak element height and set target url through properties. Only one thing not obvious here, is that link target must be _New Window_. If you open link in current window, it will replace custom interface.

# Layout

Is is not recommended to set exact top and left position for element. Much better approach would be to place them in special containers called layouts. Using layouts would give approximately same results for different screen sizes. Typical form can hold a list of layouts called _2 Columns_ like its shown on a video:

<p align="center">
![](//wiki.bablosoft.com/lib/exe/fetch.php?cache=&media=makeaform.gif ':size=300')
</p>

